#
# Conditional build:
%bcond_with	tests	# tests [require localhost networking]
%bcond_without	python2	# CPython 2.x module
%bcond_without	python3	# CPython 3.x module

%define 	module	ndg-httpsclient
Summary:	Enhanced HTTPS support for httplib and urllib2 using PyOpenSSL
Summary(pl.UTF-8):	Rozszerzona obsługa HTTPS dla modułów httplib i urllib2 poprzez PyOpenSSL
Name:		python-%{module}
Version:	0.4.2
Release:	11
License:	BSD
Group:		Libraries/Python
Source0:	https://github.com/cedadev/ndg_httpsclient/archive/%{version}.tar.gz
# Source0-md5:	08236101a72bb18f9f62c123d199420b
Patch0:		%{name}-tests.patch
URL:		http://ndg-security.ceda.ac.uk/wiki/ndg_httpsclient
%if %{with python2}
BuildRequires:	python-modules >= 1:2.6
BuildRequires:	python-pyOpenSSL
BuildRequires:	python-setuptools
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.2
BuildRequires:	python3-pyOpenSSL
BuildRequires:	python3-setuptools
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
Requires:	python-modules >= 1:2.6
Requires:	python-pyOpenSSL
Requires:	python-pyasn1
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is a HTTPS client implementation for httplib and urllib2 based on
PyOpenSSL. PyOpenSSL provides a more fully featured SSL implementation
over the default provided with Python and importantly enables full
verification of the SSL peer.

%description -l pl.UTF-8
Ten moduł to implementacja klienta HTTPS dla modułów httplib i urllib2
oparta na module PyOpenSSL. PyOpenSSL udostępnia pełniejszą
implementację SSL niż domyślnie dostarczana z Pythonem i umożliwia
pełną weryfikację drugiej strony połączenia SSL.

%package -n python3-%{module}
Summary:	Enhanced HTTPS support for httplib and urllib2 using PyOpenSSL
Summary(pl.UTF-8):	Rozszerzona obsługa HTTPS dla modułów httplib i urllib2 poprzez PyOpenSSL
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.2
Requires:	python3-pyOpenSSL
Requires:	python3-pyasn1

%description -n python3-%{module}
This is a HTTPS client implementation for httplib and urllib2 based on
PyOpenSSL. PyOpenSSL provides a more fully featured SSL implementation
over the default provided with Python and importantly enables full
verification of the SSL peer.

%description -n python3-%{module} -l pl.UTF-8
Ten moduł to implementacja klienta HTTPS dla modułów httplib i urllib2
oparta na module PyOpenSSL. PyOpenSSL udostępnia pełniejszą
implementację SSL niż domyślnie dostarczana z Pythonem i umożliwia
pełną weryfikację drugiej strony połączenia SSL.

%prep
%setup -q -n ndg_httpsclient-%{version}
%patch -P 0 -p1

%build
%if %{with python2}
%py_build

%if %{with tests}
TOPDIR=$(pwd)
cd ndg/httpsclient/test
./scripts/openssl_https_server.sh &
HTTPDPID=$!
sleep 1
trap "kill $HTTPDPID" ERR
for test in test_*.py ; do
PYTHONPATH=$TOPDIR/build-2/lib %{__python} $test
done
kill $HTTPDPID
trap - ERR
cd ../../..
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
TOPDIR=$(pwd)
cd ndg/httpsclient/test
./scripts/openssl_https_server.sh &
HTTPDPID=$!
sleep 1
trap "kill $HTTPDPID" ERR
for test in test_*.py ; do
PYTHONPATH=$TOPDIR/build-3/lib %{__python3} $test
done
kill $HTTPDPID
trap - ERR
cd ../../..
%endif
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%{__rm} -r $RPM_BUILD_ROOT%{py_sitescriptdir}/ndg/httpsclient/test
%endif

%if %{with python3}
%py3_install

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/ndg/httpsclient/test
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc README.md ndg/httpsclient/LICENSE
%{py_sitescriptdir}/ndg
%if "%{py_ver}" > "2.4"
%{py_sitescriptdir}/ndg_httpsclient-%{version}-py*.egg-info
%{py_sitescriptdir}/ndg_httpsclient-%{version}-py*-nspkg.pth
%endif
%endif

%if %{with python3}
%files -n python3-%{module}
%defattr(644,root,root,755)
%doc README.md ndg/httpsclient/LICENSE
%attr(755,root,root) %{_bindir}/ndg_httpclient
%{py3_sitescriptdir}/ndg
%{py3_sitescriptdir}/ndg_httpsclient-%{version}-py*.egg-info
%{py3_sitescriptdir}/ndg_httpsclient-%{version}-py*-nspkg.pth
%endif
%changelog
* Tue Mar 11 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-ndg-httpsclient.git;a=log;h=master

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 2d6eb31
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 4f26d8f
- python 3.13 rebuild

* Sun Mar 09 2025 Jan Rękorajski <baggins@pld-linux.org> c8e035c
- use patch -P

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> a0fd22e
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 7908b23
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> ced6e20
- rebuild with python 3.10

* Fri Feb 26 2021 Jan Rękorajski <baggins@pld-linux.org> 863128a
- release 6 (by relup.sh)

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> ce83a7a
- rebuild with python 3.8
- release 5 (by relup.sh)

* Mon Jul 02 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 2d0d16a
- release 4 (by relup.sh)

* Wed Apr 05 2017 Mateusz Korniak <matkor@pld-linux.org> 80b32fe
- rel 3. Moved %{_bindir}/ndg_httpclient as uses python3

* Sat Mar 04 2017 Jakub Bogusz <qboosh@pld-linux.org> 9624f30
- updated dependencies, added tests patch, allow tests to pass

* Sat Dec 31 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> a480d3f
- rel 3; python3 subpackage added

* Sat Dec 31 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 97d009f
- up to 0.4.2

* Mon Nov 30 2015 Jacek Konieczny <jajcus@jajcus.net> aa58f59
- release 3 (by relup.sh)

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 8c368b2
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> e6cdf87
- release 2 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> d200588
- automatic change: use py_build/py_install macros

* Tue Dec 16 2014 Jakub Bogusz <qboosh@pld-linux.org> 3b152d9
- updated to 0.3.3

* Mon Nov 10 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> df64dd2
- package more files

* Mon Nov 10 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 7e4c0b7
- initial

